import 'package:mockito/mockito.dart';
import 'package:test/test.dart';
import 'package:test_helper/test_helper.dart';

void main() {
  test("theory example: calculates squared correctly", () {
    const inlineData = [-1, 0, 1, 2, 10];
    theory<int>(inlineData, (number) {
      final someMock =
          MockClass(); // use correct mocking library to create mock object ("mockito" is my favourite ;))
      final someClassUsingMock = ClassUsingMock(someMock);
      someClassUsingMock.doSomething();
      verify(someMock.doSomething());
    });
  });

  test("theory results example: some class forwards to mock class", () {
    const inlineData = [-1, 0, 1, 2, 10];
    const expected = [1, 0, 1, 4, 100];
    theoryResult<int, int>(
        inlineData, expected, (number) => Calculator().squared(number));
  });
}

class MockClass {
  void doSomething() {}
}

class ClassUsingMock {
  final MockClass someMock;

  ClassUsingMock(this.someMock);

  void doSomething() {
    someMock.doSomething();
  }
}

class Calculator {
  int squared(int num) => num * num;
}
